###################################
#
# CFME Automate Method: GroupAdmin_List_Quota_Max_Cpu_dialog
#
# Notes: This method builds a dynamic drop down of values from the category quota_max_cpu
#
###################################
begin
  # Method for logging
  def log(level, message)
    @method = 'GroupAdmin_List_Quota_Max_Cpu_dialog'
    $evm.log(level, "#{@method} - #{message}")
  end

  # dump_root
  def dump_root()
    log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
    $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
    log(:info, "Root:<$evm.root> End $evm.root.attributes")
    log(:info, "")
  end

  log(:info, "CFME Automate Method Started")

  # dump all root attributes to the log
  dump_root

  user = $evm.root['user']
  group = user.miq_group

  group_admin = user.tags(:group_admin).first
  log(:info,"Detected user:<#{user.name}> group:<#{group.description}> group.id:<#{group.id}> group_admin:<#{group_admin}>")

  category_name = 'quota_max_cpu'
  classification = $evm.vmdb('classification').find_by_name(category_name)
  log(:info, "Found classification:<#{classification.description}> id:<#{classification.id}>")

  # build hash of tag descriptions and values
  classification_tags = {}
  $evm.vmdb('classification').find_all_by_parent_id(classification.id).each { |tag| classification_tags[tag.name] = tag.description }
  log(:info, "Inspecting classification_tags:<#{classification_tags.inspect}>")

  # build
  list_values = {
    'sort_by'    => :none,
    'sort_order' => :ascending,
    'data_type'  => :string,
    'required'   => false,
    'values'     => [[nil, nil]] + classification_tags.to_a.collect { |x| x.reverse }
  }

  $evm.log('info', "Dynamic drop-down parameters: [#{list_values}]")
  list_values.each { |k,v| $evm.object[k] = v }

  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

  # Ruby rescue
rescue => err
  log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
