###################################
#
# CFME Automate Method: GroupAdmin_List_UserGroupAdminTags
#
# Notes: This method builds a dynamic drop down of values from the category quota_max_cpu
#
###################################
begin
  # Method for logging
  def log(level, message)
    @method = 'GroupAdmin_List_UserGroupAdminTags'
    $evm.log(level, "#{@method} - #{message}")
  end

  # dump_root
  def dump_root()
    log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
    $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
    log(:info, "Root:<$evm.root> End $evm.root.attributes")
    log(:info, "")
  end

  log(:info, "CFME Automate Method Started")

  # dump all root attributes to the log
  dump_root

  user = $evm.root['user']

  tags = user.tags
  log(:info, "Inspecting Tags: #{tags.inspect}")
  
  group_ids = user.tags(:group_admin)
  log(:info, "group_ids: #{group_ids.inspect}")

  groups_hash = {}
  group_ids.each do |g|
    grp = $evm.vmdb('miq_group').find_by_id(g)
    log(:info, "Group: #{grp.description} id: #{grp.id}")
    groups_hash[grp.description] = grp.id unless grp.description.starts_with?('EVM')
  end

  # groups_hash = {}
  # groups = $evm.vmdb('miq_group').all.each {|group| groups_hash[group.description] = group.id unless group.description.starts_with?('EVM')}
  log(:info, "Inspecting groups_hash:<#{groups_hash.inspect}>")

  # build
  list_values = {
    'sort_by'    => :none,
    'sort_order' => :ascending,
    'data_type'  => :string,
    'required'   => false,
    'values'     => [[nil, nil]] + groups_hash.to_a
  }

  $evm.log('info', "Dynamic drop-down parameters: [#{list_values}]")
  list_values.each { |k,v| $evm.object[k] = v }

  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

  # Ruby rescue
rescue => err
  log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
