##################################
#
# CFME Automate Method: merge_services
#
# Author: Nick Lane
#
# Notes: Retrieve a list of all online templates
#
###################################


def error(msg)
  $evm.log(:error, msg)
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = msg
  exit MIQ_OK
end

def dump_root()
  $evm.log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
  $evm.log(:info, "Root:<$evm.root> End $evm.root.attributes")
  $evm.log(:info, "")
end

begin

dump_root()

service_id = $evm.root['dialog_selected_service']
service_new_name = $evm.root['dialog_new_name']

$evm.log(:info, "Serivce id: --#{service_id}--")
old_service = $evm.vmdb('service').all.select { |service| service.id.to_i == service_id.to_i}
$evm.log(:info, "Found Service #{old_service}")

current_service = $evm.root['service']

old_service[0].vms.each { |vm|
	vm.remove_from_service
	vm.add_to_service(current_service)
}

old_service[0].remove_from_vmdb

current_service.name = service_new_name unless (service_new_name.nil?) || (service_new_name.blank?)

rescue => err
  error("[#{err}]\n#{err.backtrace.join("\n")}")
end
