##################################
#
# CFME Automate Method: organize_vms
#
# Author: Nick Lane
#
# Notes: Retrieve a list of all online templates
#
###################################


def error(msg)
  $evm.log(:error, msg)
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = msg
  exit MIQ_OK
end

def dump_root()
  $evm.log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
  $evm.log(:info, "Root:<$evm.root> End $evm.root.attributes")
  $evm.log(:info, "")
end

begin

dump_root()

service_name = $evm.root['dialog_service_name']
vms = $evm.root['dialog_vms']

vm_array = vms.split(",")

service = String.new
$evm.log(:info, "Index #{vm_array}")
vm_array.each_index {|i|
  $evm.log(:info, "Index #{i} contents: #{vm_array[i]}")
  vm_collect = $evm.vmdb('vm').all.select {|x| x.name.to_s == "#{vm_array[i]}"}
  vm = vm_collect[0]
  next if vm.nil?

  if service == ''
    $evm.log(:info, "Initializing Service")
    service = vm.service
    service.name = service_name unless service_name.blank?
  else
    $evm.log(:info, "Adding VM")
    old_service = vm.service
    vm.remove_from_service
    vm.add_to_service(service)
  end

}

rescue => err
  error("[#{err}]\n#{err.backtrace.join("\n")}")
end
