###################################
#
# CFME Automate Method: retire_vm
#
# Author: Jason Dillaman
#
# Notes: Retires a local VM
#
# Inputs: vm: the target service or VM
#
###################################

def dump_root()
  $evm.log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
  $evm.log(:info, "Root:<$evm.root> End $evm.root.attributes")
  $evm.log(:info, "")
end


def error(msg)
  $evm.log(:error, msg)
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = msg
  exit MIQ_OK
end

def get_virtual_machine()
  vm = $evm.root['vm']
  error("Failed to retrieve VM") unless vm
  $evm.log(:info, "Located VM: [#{vm.name}]")
  vm
end


begin
  dump_root()
  
  $evm.log(:info, "Retiring VM")
  
  vm = get_virtual_machine()
  $evm.log(:info, "VM Found: #{vm.name}")
  vm.retire_now()

rescue => err
  error("[#{err}]\n#{err.backtrace.join("\n")}")
end
