###################################
#
# CFME Automate Method: RetireServiceNow
#
# Notes: Retire Service Now
#
###################################
require 'socket'

begin
  #########################
  #
  # Method: log
  # Description: Send messages to the log and create a body for email
  #
  ##########################
  def log(level, message)
    @method = 'RetireServiceNow'
    $evm.log(level, "#{@method} - #{message}")
  end

  #########################
  #
  # Method: dumpRoot
  # Description: Dump Root information
  #
  ##########################
  def dumpRoot
    log(:info, "Root:<$evm.root> Begin Attributes")
    $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attributes - #{k}: #{v}")}
    log(:info, "Root:<$evm.root> End Attributes")
    log(:info, "")
  end

  #########################
  #
  # Method: RetireService
  # Inputs: $evm.root['service']
  # Description: Set Service Retire date
  #
  ##########################
  def RetireService(service)
    #service.attributes.sort.each { |k, v| log(:info, "Service:<#{service.name}> Attributes - #{k}: #{v.inspect}")}
    service_rec = $evm.vmdb('service').find_by_id(service.attributes['id'])
    service_rec.attributes.sort.each { |k, v| log(:info, "Service Record:<#{service_rec.name}> Attributes - #{k}: #{v.inspect}")}

    #service_rec.attributes['retires_on'] = (DateTime.now - 1.day)
    #service_rec.save

    #service_rec.update_attributes(retires_on: (DateTime.now - 1.day))
    service_rec.retire_now
  end

  log(:info, "CFME Automate Method Started")

  # List the types of object we will try to detect
  #obj_types = %w{ vm host storage ems_cluster ext_management_system service }
  obj_types = %w{ service }
  obj_type = $evm.root.attributes.detect { |k,v| obj_types.include?(k) }

  # dump root object attributes
  #dumpRoot

  # If obj_type is NOT nil
  unless obj_type.nil?
    rootobj = obj_type.first
    obj = obj_type.second
    log(:info, "Detected Object Type:<#{rootobj}>")
    log(:info, "")

    case rootobj
    when 'service' then RetireService(obj)
    end
  end

  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

  # Set Ruby rescue behavior
rescue => err
  log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
