##################################
#  Title: Set Group Quota
#  Author: Nick Lane
#
#  Summary: Sets the tags associated for the groups quota.
#
##################################

def dump_root()
  $evm.log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
  $evm.log(:info, "Root:<$evm.root> End $evm.root.attributes")
  $evm.log(:info, "")
end

def assign_tag(group, tag_name, value)
  $evm.log(:info, "Assigning tag: #{tag_name} value: #{value}")
  if $evm.execute('tag_exists?', tag_name, value)
      $evm.log(:info, "Tag exists")
      group.tag_assign("#{tag_name}/#{value.downcase}")
   else
      $evm.execute('tag_create', tag_name, :name => "#{value}", :description => "#{value}")
      $evm.log(:info, "Creating tag: #{tag_name}/#{value.downcase.chomp}")
      tag_response = group.tag_assign("#{tag_name}/#{value.downcase.chomp}")
      $evm.log(:info, "Tag assign response: #{tag_response.inspect}")
   end
end

begin
  
  dump_root()

  $evm.log(:info, "Set Quota STARTING")
  group_name = $evm.root['dialog_group_name']
  new_mem = $evm.root['dialog_new_mem_quota']
  new_cpu = $evm.root['dialog_new_cpu_quota']
  hosting_segment = $evm.root['dialog_hosting_segment']

  group = $evm.root['user'].miq_group

  mem_quota = "intuit_mem_#{hosting_segment}_quota"
  assign_tag(group, mem_quota, new_mem)

  cpu_quota = "intuit_cpu_#{hosting_segment}_quota"
  assign_tag(group, cpu_quota, new_cpu)


  prov = $evm.root['service_template_provision_task']
  prov.destination.remove_from_vmdb

  $evm.log(:info, "Set Quota - #{prov.inspect}")

rescue => err
  $evm.log(:info, "(#{err}) - #{err.backtrace}")
end
