##################################
#
# CFME Automate Method: vm_to_service
#
# Author: Nick Lane
#
# Notes: Retrieve a list of all online templates
#
###################################


def error(msg)
  $evm.log(:error, msg)
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = msg
  exit MIQ_OK
end

def dump_root()
  $evm.log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
  $evm.log(:info, "Root:<$evm.root> End $evm.root.attributes")
  $evm.log(:info, "")
end

begin

dump_root()


service_id = $evm.root['dialog_selected_service']

$evm.log(:info, "Serivce id: --#{service_id}--")
service = $evm.vmdb('service').all.select { |service| service.id.to_i == service_id.to_i}

$evm.log(:info, "Found Service #{service}")
vm = $evm.root['vm']

vm.add_to_service(service[0])

rescue => err
  error("[#{err}]\n#{err.backtrace.join("\n")}")
end
