###################################
#
# CFME Automate Method: approve_request
#
# Author: Wayne Chatham
#
# Notes: CRUST approve_request method
#
# Inputs: miq_request
#
# Mods:
#
###################################

require 'cgi'

def dump_root()
  log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
  $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
  log(:info, "Root:<$evm.root> End $evm.root.attributes")
  log(:info, "")
end

def error(msg)
  log(:error, "#{msg}")
  task = $evm.root['automation_task']
  task.object_send(:update_and_notify_parent,
                   :state => 'finished',
                   :status => 'Error',
                   :message => "#{msg}")
  exit MIQ_OK
end

def get_miqrequest(reqid)
  request = $evm.vmdb('miq_request').find_by_id(reqid)
  error("Failed to retrieve request") unless request
  log(:info, "Located request: #{reqid} submitted by: [#{request.userid}]")
  return request
end

def log(level, msg)
  @method = 'reconfigure_vm'
  $evm.log(level, "#{@method}: #{msg}")
end

def retry_method(msg, retry_time=1.minute)
  log(:warn, "Retrying in #{retry_time} seconds: [#{msg}]")
  $evm.root['ae_result'] = 'retry'
  $evm.root['ae_reason'] = msg.to_s
  $evm.root['ae_retry_interval'] = retry_time
  exit MIQ_OK
end

begin
  log(:info, "Entering approve_request method")
  # Turn on debugging
  @debug = true
  dump_root()

  # Get CF VM
  reqid = $evm.root['reqid']
  reqname = $evm.root['reqname']
  request = get_miqrequest(reqid)
  request.approve("admin", "Auto-Approved")

  $evm.root['ae_result'] = 'ok'
  $evm.root['ae_reason'] = ''
  exit MIQ_OK

end
