###################################
#
# CFME Automate Method: retire_service
#
# Author: Mai Lubega
#
# Notes: Retires an service by guid 
#
# Inputs: $evm.root['guid']
#
# Mods:
#
###################################
def log(level, msg)
  @method = 'retire_service'
  $evm.log(level, "#{@method}: #{msg}")
end

def dump_root()
  $evm.log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
  $evm.log(:info, "Root:<$evm.root> End $evm.root.attributes")
  $evm.log(:info, "")
end

def error(msg)
  $evm.log(:error, msg)
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = msg
  exit MIQ_OK
end

begin

log(:info, "Automate Method Retire Service Started")


service_guid = $evm.root['guid'] 

log(:info,"Looking up Service GUID: #{service_guid}" )

service = $evm.vmdb('service').find_by_guid(service_guid)
log(:info,"Service Found: #{service.inspect}" )

service.retire_now
log(:info,"Retiring Service" )



log(:info, "Automate Method Retire Service Ended")
exit MIQ_OK
end
