###################################
#
# CFME Automate Method: reboot_os
#
# Author: Nick Lane
#
# Notes: Downloads the HPSA agent installer, transfers it to the new
#        VM, and executes the installer
#
# Inputs: vm: the target VM
#
# Mods:
#
###################################




def dump_root()
  $evm.log(:info, "Resize - Root:<$evm.root> Begin $evm.root.attributes")
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "Resize - Root:<$evm.root> Attribute - #{k}: #{v}")}
  $evm.log(:info, "Resize - Root:<$evm.root> End $evm.root.attributes")
  $evm.log(:info, "")
end

def error(msg)
  $evm.log(:error, "Second Disk Resize Failed: [#{msg}]")
  $evm.current['result'] = 'error'
  $evm.current['reason'] = msg.to_s
  exit MIQ_OK
end


def get_virtual_machine()
  case $evm.root['vmdb_object_type']
  when 'miq_provision'
    vm = $evm.root['miq_provision'].vm
  when 'vm'
    vm = $evm.root['vm']
  when 'automation_task'
    vm = $evm.root['vm']
  end
  raise "VM not found" unless vm
  vm
end

begin

  dump_root()
  vm = get_virtual_machine()
  
  $evm.log(:info, "Vm Hardware: #{vm.hardware.storage_adapters}")
  
  vm.reboot_guest
  sleep(60)
  $evm.log(:info, "VM INSPECT: #{vm.inspect}")

  #sleep(5)

#  while vm.power_state != "off"
#    $evm.log(:info, "Waiting for VM to power off: #{vm.power_state}")
#    sleep(60)
#  end

#  vm.start

#  while vm.power_state != "on"
#    $evm.log(:info, "Waiting for VM to power on: #{vm.power_state}")
#    sleep(60)
#  end

  $evm.log(:info, "vm power_state #{vm.power_state}")
rescue => err
  error("[#{err}]\n#{err.backtrace.join("\n")}")
end
