###################################
#
# Automate Method: POC_PharosMetadataFromDB
#
# by Earl Waud
#
# Notes: This method Performs the following functions:
# 1. Open a connection to the Pharos DB
# 2. Query the Pharos Metadata for a VM
# 3. Close the connection to the Pharos DB
# 4. If metadata found in Query updates VM tags and properties accordingly
#
###################################
begin
  # Method for logging
  def log(level, message)
    @method = 'POC_PharosMetadataFromDB'
    $evm.log(level, "#{@method} - #{message}")
  end

  # dump_root
  def dump_root()
    log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
    $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
    log(:info, "Root:<$evm.root> End $evm.root.attributes")
    log(:info, "")
  end

  # Log method name for debugging
  log(:info, "POC_PharosMetadataFromDB Method Started")

  # dump all root attributes to the log
  dump_root


  # Get Provisioning object
  vm = $evm.root['vm']
  raise "VM object not found" if vm.nil?
  log(:info,"VM Found:<#{vm.name}>")

  # Get OS Type from the VM platform
  product  = vm.operating_system['product_name'].downcase
  raise "VM OS product cannot be found" if vm.nil?
  log(:info,"VM Source Product:<#{product}>")

  ems = vm.ext_management_system
  raise "EMS object not found" if ems.nil?
  log(:info,"VM Source EMS:<#{ems.name}>")


  # debug
  $evm.log(:info, "evm.log:Earl's PharosDB script")
  log(:info, "log:Earl's PharosDB script");

  # 1. Open a connection to the Pharos DB


  # 2. Query the Pharos Metadata for a VM


  # 3. Close the connection to the Pharos DB


  # 4. If metadata found in Query updates VM tags and properties accordingly



  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

  


  # Exit method
  log(:info, "POC_PharosMetadataFromDB Automate Method Ended")
  exit MIQ_OK

  # Set Ruby rescue behavior
rescue => err
  log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_STOP
end
