#no oci8 ruby gem require 'oci8'
require 'rubygems'
require 'json'
require 'net/http'
begin
def log (level, msg)
    @method = 'Import MetaData Automation'
    $evm.log(level, "<#{@method}>: #{msg}")
end



def db_connect
  @conn = nil
  log(:info, "Getting object parameters and creating database url")
  log(:info, "EVM Object: #{$evm.object.inspect}")
  pharosdb_host = $evm.object['pharos_db_host']
  pharosdb_port = $evm.object['pharos_db_port']
  pharosdb_user = $evm.object['pharos_db_user']
  pharosdb_name = $evm.object['pharos_db_name']
  log(:info,"pharos db name obtained is #{pharosdb_name}")
  pharosdb_password = $evm.object.decrypt('pharos_db_password')
  dburl = "//#{pharosdb_host}:#{pharosdb_port}/#{pharosdb_name}"
  log(:info, "Connecting to db with url #{dburl} using #{pharosdb_user}/********")
  #no oci8 ruby gem @conn = OCI8.new(pharosdb_user, pharosdb_password, dburl)
  log(:info, "Successfully connected to database")
end 



def meta_data_import vm
 log(:info, "Begin meta data import for #{vm.name}")
  if non_cloudforms_imported? vm
#no oci8 ruby gem     log(:info, "Non cloudforms provisioned VM:  #{vm.name}")
#no oci8 ruby gem     pharos_hosts = $evm.object['pharos_hosts']
#no oci8 ruby gem     log(:info, "Host of the vm under pharos hosts? :  #{vm.name} #{@mh.name}")
#no oci8 ruby gem     if pharos_hosts.include? @mh.name
#no oci8 ruby gem        log(:info, "Host of the vm under pharos hosts, begin pharos import process :  #{vm.name} #{@mh.name}")
#no oci8 ruby gem        pharos_vm_import vm
#no oci8 ruby gem     else
      log(:info, "Host of the vm not under pharos hosts, begin non pharos import process :  #{vm.name} #{@mh.name}")
      non_pharos_vm_import vm
#no oci8 ruby gem     end
  end   
end


def non_cloudforms_imported? vm
#need to check for vmware login.
log(:info, "Test if the vm is non cloudforms provisioned? #{vm.name}")    
return !(vm.tags.include? "intuit_template")
end


def get_pharos_vm_details vm_name
sql_statement = "select * from pharos_cf_import_view where UPPER(host_name) = UPPER('#{vm_name}')"
log(:info, "Executing SQL #{sql_statement}")
col_to_index = {:ENV_ID=>0, :BUSINESS_UNIT=>1, :PROJECT_NAME=>2, :SERVICE_NAME=>3, :SERVICE_COMPONENT_NAME=>4, :HOST_NAME=>5, :HOST_IP_ADDRESS=>6, :NFSHOSTNAME=>7, :NFSIP=>8, :HOSTING_SEGMENT_NAME=>9, :ENV_LIFECYCLE=>10, :SECURITY_LEVEL=>11, :FAULT_DOMAIN_NAME=>12, :INSTANCE_SIZE=>13, :TEMPLATE=>14, :ENV_TYPE=>15, :SERVICE_CREATED_BY=>16, :CREATED_DATE=>17, :NW_HOSTNAME=>18, :NW_NETWORK_TYPE=>19, :NW_IP_ADDRESS=>20,:NW_NETWORK_ADDRESS=>21,:STORAGE_HOST_NAME=>22, :STORAGE_BLOCK_ID=>23, :FULL_PATH=>24, :LUN_PATH=>25, :EXPORT_TYPE=>26, :CMODE=>27, :CMODE_CLUSTER=>28, :MANAGEMENT_HOST=>29}
 #networks = [{:host_name=>'',:network_type=>'',:network_ip_addr=>''}]
 networks = []
 #storage = {:full_path=>'',:lun_path=>'',:export_type=>'',:cmode=>'',cmode_cluster=>'',:management_host=>''}
 storage = {}
 #vm_pharos_data = {:meta=>{},:networks=>[],:storage=>{}}
 vm_pharos_data = {}
  @conn.exec(sql_statement).fetch do |row|
    log(:info, "Got response: #{row.join(',')}")
        if vm_pharos_data.empty?
            meta_info = {}    
            meta_info[:bu] = row[col_to_index[:BUSINESS_UNIT]]
            meta_info[:project_name] = row[col_to_index[:PROJECT_NAME]] 
            meta_info[:service_name] = row[col_to_index[:SERVICE_NAME]]
            meta_info[:service_comp_name] = row[col_to_index[:SERVICE_COMPONENT_NAME]]
            meta_info[:name] = row[col_to_index[:HOST_NAME]]
            meta_info[:ip_address] = row[col_to_index[:HOST_IP_ADDRESS]]
            meta_info[:nfs_host_name] = row[col_to_index[:NFSHOSTNAME]]
            meta_info[:nfs_ip_address] = row[col_to_index[:NFSIP]]    
            meta_info[:hosting_segment_name] = row[col_to_index[:HOSTING_SEGMENT_NAME]]
            meta_info[:env_lifecycle] = row[col_to_index[:ENV_LIFECYCLE]]
            meta_info[:security_level] = row[col_to_index[:SECURITY_LEVEL]] 
            meta_info[:fault_domain] = row[col_to_index[:FAULT_DOMAIN_NAME]]     
            meta_info[:instance_size] = row[col_to_index[:INSTANCE_SIZE]]
            meta_info[:template] = row[col_to_index[:TEMPLATE]]
            meta_info[:env_type] = row[col_to_index[:ENV_TYPE]]
            meta_info[:created_by] = row[col_to_index[:SERVICE_CREATED_BY]] 
            meta_info[:created_on] = row[col_to_index[:CREATED_DATE]]    
            vm_pharos_data[:meta_info] = meta_info
        end
        if storage.empty?
            storage[:block_id] = row[col_to_index[:STORAGE_BLOCK_ID]]
            storage[:full_path] = row[col_to_index[:FULL_PATH]]
            storage[:lun_path] = row[col_to_index[:LUN_PATH]]
            storage[:export_type] = row[col_to_index[:EXPORT_TYPE]]
            storage[:cmode] = row[col_to_index[:CMODE]]
            storage[:cmode_cluster] = row[col_to_index[:CMODE_CLUSTER]]
            storage[:management_host] = row[col_to_index[:MANAGEMENT_HOST]]    
        end     
        network_obj = {}
        network_obj[:host_name] = row[col_to_index[:NW_HOSTNAME]]
        network_obj[:network_type] = row[col_to_index[:NW_NETWORK_TYPE]]
        network_obj[:ip_address] = row[col_to_index[:NW_IP_ADDRESS]]
        network_obj[:network_address] = row[col_to_index[:NW_NETWORK_ADDRESS]]
        networks<< network_obj
  end
 vm_pharos_data[:networks] = networks unless networks.empty?
 vm_pharos_data[:storage] = storage unless storage.empty?
 return vm_pharos_data      
end

   

def pharos_vm_import vm
log(:info,'Pharos vm import method called!')
pharos_vm_details = get_pharos_vm_details vm.name
if pharos_vm_details.empty?
  log(:info, "Unable to retreive info from Pharos db, proceeding with non pharos vm import #{vm.name}")         
non_pharos_vm_import vm
else
   #vm.tag_assign("Metadata_import/Pharos Updated")
   vm_pharos_data = pharos_vm_details
   meta_info = vm_pharos_data[:meta_info] 
  #add tagging here   tag_pharos_imported vm,vm_pharos_data 
  log(:info, "Retreived info from Pharos db,  #{vm.name}  #{vm_pharos_data}")      
end
  
end
  
def non_pharos_vm_import vm
  log(:info, "Inside non pharos vm import #{vm.name}")
  log(:info, "Searching glass for #{vm.name}")    
 vm_non_pharos =  search_glass vm.name    
 
  #add tagging here   tag_non_pharos vm,vm_non_pharos unless vm_non_pharos.empty? 

 if vm_non_pharos.empty?
   #vm.tag_assign("Metadata_import/Import Failed")
 end
  return vm_non_pharos   
end


def process_vms current_vm
  vm = $evm.vmdb('vm').find_by_id(current_vm)
  meta_data_import vm
  #@mh.vms.each do |vm|
   #meta_data_import vm
  #end
end



def search_glass vm_name
  log(:info, "Glass search for #{vm_name}")     
begin
    glass_url = $evm.object['glass_url']
    #glass_url= http://qy1opconwsprd02.corp.intuit.net:80/glass/v1/ 
    url = glass_url+'vmware/search/'+vm_name

    if dns_zone.include?("corplab")
      proxy_addr = '10.152.252.17'
      proxy_port = 3128
      log(:info, "Searching using url  #{url}")
      resp = Net::HTTP::Proxy(proxy_addr, proxy_port).get_response(URI.parse(url))
    else
      log(:info, "Searching using url  #{url}")
      resp = Net::HTTP.get_response(URI.parse(url))
    end

    data = resp.body
    result = JSON.parse(data)
    vms =  result["results"]["vmware_search_results"]["virtualMachines"]["content"]
    vm_non_pharos = {}
    meta_info={}
    if !vms.nil?
        vms.each do |vm|
            vm_url = vm["id"]["href"]
            log(:info,"connecting to vm directly using #{vm_url}")
            vm_resp = Net::HTTP.get_response(URI.parse(vm_url))
            vm_data = vm_resp.body
            vm_result = JSON.parse(vm_data)
            #puts vm_result
            bu_info = nil
            bu_info = vm_result["dependentBUAppFromESCQB"]["content"][0] unless vm_result["dependentBUAppFromESCQB"].nil?
            qtrees = nil
            qtrees = vm_result["sharedStorage"]["content"] unless vm_result["sharedStorage"].nil?
            #puts bu_info
            meta_info[:bu]=bu_info['buShortName'] unless bu_info.nil?
            meta_info[:project_name]=bu_info['productName'] unless bu_info.nil?
            meta_info[:ip_address]=vm_result['ipAddress']
            meta_info[:name]=vm_result['name'] 
            meta_info[:owner]=bu_info['owner'] unless bu_info.nil?
            vm_non_pharos[:meta_info] = meta_info
            vm_non_pharos[:storage] = get_storage_info qtrees unless qtrees.nil?
            log("info"," VM: #{vm_name} glass Info: #{vm_non_pharos}")
        end    
    end    
 rescue Exception => e
   log(:error, " Error. #{e}")
end
return vm_non_pharos
end

def get_storage_info qtrees
storage_infos = []
    qtrees.each do |qtree|
        storage_info = {}
        qtreeName = qtree["qtreeName"]
        node = qtree["netAppQtreeHierarchy"]["node"]
        volume = qtree["netAppQtreeHierarchy"]["volume"]
        full_path = node+"/"+volume+"/"+qtreeName
        storage_info[:full_path]=full_path
        storage_info[:export_type]="nfs"
        storage_info[:cmode]="TRUE" if qtree["netAppQtreeHierarchy"]["clusterName"]&&qtree["netAppQtreeHierarchy"]["vserver"]
        storage_info[:cmode_cluster]= qtree["netAppQtreeHierarchy"]["clusterName"]
        storage_info[:management_host]=qtree["netAppQtreeHierarchy"]["dfm"]
        storage_infos<< storage_info
    end
    return storage_infos
end

def tag_vm vm,category,tag
    if $evm.execute('tag_exists?', category, tag)
      vm.tag_assign(category+"/"+tag)
     else
      $evm.execute('tag_create', category, :name => tag, :description => tag)
       vm.tag_assign(category+"/"+tag) 
    end    
end    


def tag_pharos_imported vm,vm_pharos_data
    vm.tag_assign("Metadata_import/Pharos Updated")
    meta_info = vm_pharos_data[:meta_info] 
    if !meta_info.nil?
    tag_vm vm,"intuit_bu",meta_info[:bu].upcase unless  meta_info[:bu].nil?
    tag_vm vm,"intuit_project_name",meta_info[:project_name] unless  meta_info[:project_name].nil?
    tag_vm vm,"intuit_service_name",meta_info[:service_name] unless  meta_info[:service_name].nil?
    tag_vm vm,"intuit_software_component",meta_info[:service_comp_name] unless  meta_info[:service_comp_name].nil?
    tag_vm vm,"intuit_pharos_import_env",meta_info[:env_lifecycle] unless  meta_info[:env_lifecycle].nil?
    tag_vm vm,"intuit_security_level",meta_info[:security_level] unless  meta_info[:security_level].nil?
    tag_vm vm,"intuit_fd",meta_info[:fault_domain] unless  meta_info[:fault_domain].nil?
    tag_vm vm,"intuit_instance_size",meta_info[:instance_size] unless  meta_info[:instance_size].nil?
    tag_vm vm,"intuit_template",meta_info[:template] unless  meta_info[:template].nil?
    tag_vm vm,"intuit_security_zone",meta_info[:env_type] unless  meta_info[:env_type].nil?
    tag_vm vm,"intuit_hs",meta_info[:hosting_segment_name] unless  meta_info[:hosting_segment_name].nil?
    
    log(:info, "Set custom attributes")
    vm.custom_set("Intuit_Pharos_IP_Address", meta_info[:ip_address]) unless meta_info[:ip_address].nil?
    vm.custom_set("Intuit_Pharos_NFS_Hostname", meta_info[:nfs_host_name]) unless meta_info[:nfs_host_name].nil?
    vm.custom_set("Intuit_Pharos_NFS_IP_Address", meta_info[:nfs_ip_address]) unless meta_info[:nfs_ip_address].nil?
    vm.custom_set("Intuit_Pharos_Created_By", meta_info[:created_by]) unless meta_info[:created_by].nil?
    vm.custom_set("Intuit_Pharos_Created_On", meta_info[:created_on]) unless meta_info[:created_on].nil?
    end
    log(:info,"Set custom attributes storage related")
    storage_details = vm_pharos_data[:storage]
    if !storage_details.nil?
        vm.custom_set("Intuit_Pharos_Storage_Block_Id", storage_details[:block_id]) unless storage_details[:block_id].nil?
        vm.custom_set("Intuit_Pharos_Storage_Full_Path", storage_details[:full_path]) unless storage_details[:full_path].nil?
        vm.custom_set("Intuit_Pharos_Storage_Lun_Path", storage_details[:lun_path]) unless storage_details[:lun_path].nil?
        vm.custom_set("Intuit_Pharos_Storage_Cmode_Cluster", storage_details[:cmode_cluster]) unless storage_details[:cmode_cluster].nil?
        vm.custom_set("Intuit_Pharos_Storage_Management_Host", storage_details[:management_host]) unless storage_details[:management_host].nil?
        tag_vm vm,"intuit_storage_type",storage_details[:export_type] unless  storage_details[:export_type].nil?
        tag_vm vm,"intuit_storage_cmode",storage_details[:cmode] unless  storage_details[:cmode].nil?
    end             
end

def tag_non_pharos vm,vm_non_pharos
     vm.tag_assign("Metadata_import/Non-Pharos Updated")
     meta_info = vm_non_pharos[:meta_info]
     if !meta_info.nil?
        tag_vm vm,"intuit_bu",meta_info[:bu].upcase unless  meta_info[:bu].nil?
        tag_vm vm,"intuit_project_name",meta_info[:project_name] unless  meta_info[:project_name].nil?
        vm.custom_set("Intuit_Non_Pharos_Owner", meta_info[:owner]) unless meta_info[:owner].nil?
        vm.custom_set("Intuit_Non_Pharos_IP_Address", meta_info[:ip_address]) unless meta_info[:ip_address].nil? 
     end
     storage_details = vm_non_pharos[:storage]
     if !storage.nil?
        st_index = 1
         storage_details.each_with_index do |value,index|
                vm.custom_set("Intuit_Pharos_Storage_full_path_#{index+1}", value[:full_path]) unless value[:full_path].nil?
                vm.custom_set("Intuit_Pharos_Storage_cmode_cluster_#{index+1}", value[:cmode_cluster]) unless value[:cmode_cluster].nil?
                vm.custom_set("Intuit_Pharos_Storage_management_host_#{index+1}", value[:management_host]) unless value[:management_host].nil?
                vm.custom_set("Intuit_Pharos_Storage_Export_Type_#{index+1}", value[:export_type]) unless  value[:export_type].nil? 
                vm.custom_set("Intuit_Pharos_Storage_cmode_#{index+1}", value[:cmode]) unless  value[:cmode].nil? 
        end    
    end 
end

log("info", "Non CF Data Import Automate Method Started")
#@mh = nil
#@mh = $evm.root['ext_management_system'] if $evm.root['vmdb_object_type']=='ext_management_system' 
#log(:info, "Got Management host from $evm.root['ext_management_system']")
#raise "#{@method} - Management host object not found" if @mh.nil?
#log(:info,"Management host Found:<#{@mh.name}>")
dns_zone = $evm.current['dns_zone']
log(:info, "Got dns_zone from $evm.current['dns_zone']")
current_vm = $evm.current['metadata_vm']
#no oci8 ruby gem db_connect
process_vms current_vm
log("info", "Non CF Data Import  Automate Method Ended")
exit MIQ_OK
end
