###################################
#
# CFME Automate Method: metadata_instantiation
#
# This method validates the service provision request using the values
# [max_vms, max_cpus, max_memory] from values in the model
#
###################################

def log (level, msg)
    @method = 'Import MetaData Automation'
    $evm.log(level, "<#{@method}>: #{msg}")
end

def instantiate(uri)
  result = $evm.instantiate(uri)
  error("Failed to execute #{GET_VIX_PLATFORM_URI}") unless result
  error(result['reason']) unless result['result'] == 'ok'
  return result
end

log(:info, "metadata_instantiation Automate Method Started")
@mh = nil
@mh = $evm.root['ext_management_system'] if $evm.root['vmdb_object_type']=='ext_management_system' 
raise "#{@method} - Management host object not found" if @mh.nil?
log(:info, "Got Management host from $evm.root['ext_management_system']")
log(:info,"Management host Found:<#{@mh.name}>")

metadata_code = "/Intuit/Integration/meta_data_import/metadata_from_instance"
vms = @mh.vms.select {|vm| vm.active && vm.tags.select{|tag| tag.include? "intuit_bu"}.length < 1}
$evm.log(:info, "VMs: #{vms.length}")
count = 1
vms.each{|vm|
  $evm.current['metadata_vm'] = vm.id
  log(:info, "VM Missing Service #{count}, VM name:<#{vm.name}")
  instantiate metadata_code
  count=count+1
}

log(:info, "Missing Service automation complete")
