####################################
#
# CFME Automate Method: get_service_tags
#
# Author: Nick Lane
#
# Notes: Gathers the tags associated with a service to add a provision
#
# Inputs: Service
#
# Mods:
#
###################################

def dump_root()
  $evm.log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
  $evm.log(:info, "Root:<$evm.root> End $evm.root.attributes")
  $evm.log(:info, "")
end


def error(msg)
  $evm.log(:error, msg)
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = msg
  exit MIQ_OK
end

begin
  service = $evm.root['service']
  $evm.log(:info, "Service Inspect #{service.inspect_all}")
  tags = service.tags
  $evm.log(:info, "Service Tags: #{tags}")
  tag_hash = {}
  tags.each do |tag|
    $evm.log(:info, "Tag inspect: #{tag.inspect}")
    tag_split = tag.split('/')
   
    #display = However I can figure out how to get the display value for a tag
    tag_hash[tag_split[0]] = tag_split[1]

  end
  $evm.log(:info, "Tag result #{tag_hash}")
  service_now_app             = tag_hash['intuit_sn_application'].split('_').each {|app_string| app_string.capitalize!}.join(' ').gsub(/1234/, '(').gsub(/4321/, ')')
  service_now_execution_zone  = tag_hash['intuit_sn_execution_zone'].split('_').each {|app_string| app_string.capitalize!}.join(' ')
  service_now_environment     = tag_hash['intuit_sn_environment'].split('_').each {|app_string| app_string.capitalize!}.join(' ').gsub(/1234/, '(').gsub(/4321/, ')')
  $evm.log(:info, "service now application name:#{service_now_app} Service now execution zone #{service_now_execution_zone} Service Now Environment #{service_now_environment}")

  $evm.root['dialog_service_name']              = service.name
  $evm.root['dialog_service_description']       = service.description
  $evm.root['dialog_option_0_project_acronym']  = tag_hash['intuit_project_acronym']
  $evm.root['dialog_tag_0_intuit_patch_cycle']  = tag_hash['intuit_patch_cycle']
  $evm.root['dialog_tag_0_intuit_patch_window'] = tag_hash['intuit_patch_window']
  $evm.root['dialog_option_0_application_name'] = service_now_app
  $evm.root['dialog_option_0_execution_zone']   = service_now_execution_zone
  $evm.root['dialog_option_0_environment']      = service_now_environment
  $evm.root['dialog_option_0_sox_compliant']    = tag_hash['intuit_sn_sox_compliant']

  dump_root
rescue => err
  error("[#{err}]\n#{err.backtrace.join("\n")}")
end
