begin
  task = $evm.root['service_template_provision_task']
  exit MIQ_OK unless task

  ae_result = $evm.root['ae_result']
  status    = $evm.inputs['status']

  if ae_result == 'error'
    task.object_send(:update_and_notify_parent, 
                     :state => 'finished', 
                     :status => 'Error',
                     :message => "#{status || "Unknown error occurred:"} [#{$evm.object.current_field_name}]")
                     exit MIQ_OK
  elsif status == "provision_complete"
    task.finished("Provision Complete")
  else
    task.message = status unless status == '_blank_'
  end
rescue => err
  $evm.log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
end
