###################################
#
# CFME Automate Method: ApproveRequest
#
# This method is executed when the provision request is auto-approved
#
###################################
begin
  # Method for logging
  def log(level, message)
    @method = 'ApproveRequest'
    $evm.log(level, "#{@method} - #{message}")
  end

  # dump_root
  def dump_root()
    log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
    $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
    log(:info, "Root:<$evm.root> End $evm.root.attributes")
    log(:info, "")
  end

  log(:info, "CFME Automate Method Started")

  # dump all root attributes to the log
  dump_root

  # Auto-Approve request
  log(:info, "AUTO-APPROVING")
  $evm.root["miq_request"].approve("admin", "Auto-Approved")

  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

  # Set Ruby rescue behavior
rescue => err
  log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
