###################################
#
# CFME Automate Method: PendingRequest
#
# Notes: This method is executed when the provisioning request is NOT auto-approved
#
###################################
begin
  # Method for logging
  def log(level, message)
    @method = 'PendingRequest'
    $evm.log(level, "#{@method} - #{message}")
  end

  # dump_root
  def dump_root()
    log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
    $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
    log(:info, "Root:<$evm.root> End $evm.root.attributes")
    log(:info, "")
  end

  log(:info, "CFME Automate Method Started")

  # dump all root attributes to the log
  dump_root

  # Get objects
  provision_request = $evm.root['miq_request'].resource
  msg = $evm.object['reason']
  log(:info,"#{msg}")

  # execute email method to notify the requester
  #$evm.instantiate("/Alert/EmailNotifications/request_pending?reason=>#{msg}")

  # Raise automation event: request_pending
  $evm.root["miq_request"].pending

  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

  # Set Ruby rescue behavior
rescue => err
  log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
