###################################
#
# CFME Automate Method: service_request_pending
#
# Notes: This method is executed when the service request is NOT auto-approved
#
###################################
begin
  # Method for logging
  def log(level, message)
    @method = 'service_request_pending'
    $evm.log(level, "#{@method} - #{message}")
  end

  # dump_root
  def dump_root()
    log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
    $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
    log(:info, "Root:<$evm.root> End $evm.root.attributes")
    log(:info, "")
  end

  log(:info, "CFME Automate Method Started")

  # dump all root attributes to the log
  dump_root

  # get the request object from root
  miq_request = $evm.root['miq_request']
  log(:info, "miq_request.id:<#{miq_request.id}> miq_request.options[:dialog]:<#{miq_request.options[:dialog].inspect}>")

  # lookup the service_template object
  service_template = $evm.vmdb(miq_request.source_type, miq_request.source_id)
  log(:info, "service_template id:<#{service_template.id}> service_type:<#{service_template.service_type}> description:<#{service_template.description}>")

  # Get objects
  msg = $evm.object['reason']
  log(:info, "#{msg}")

  # Raise automation event: request_pending
  miq_request.pending

  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

  # Ruby rescue
rescue => err
  log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
