###################################
#
# CFME Automate Method: service_request_rejected
#
# Notes: This method runs when the service request quota validation has failed
#
###################################
begin
  # Method for logging
  def log(level, message)
    @method = 'service_request_rejected'
    $evm.log(level, "#{@method} - #{message}")
  end

  # dump_root
  def dump_root()
    log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
    $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
    log(:info, "Root:<$evm.root> End $evm.root.attributes")
    log(:info, "")
  end

  log(:info, "CFME Automate Method Started")

  # dump all root attributes to the log
  dump_root

  # Deny the request
  log(:info, "Request denied because of Quota")
  $evm.root["miq_request"].deny("admin", "Quota Exceeded")
  #$evm.root["miq_request"].pending("admin", "Quota Exceeded")


  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

  # Set Ruby rescue behavior
rescue => err
  log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
