begin
  task = $evm.root['service_template_provision_task']
  exit MIQ_OK unless task
 
  ae_result = $evm.root['ae_result']
  status    = $evm.inputs['status']
  
  if ae_result == 'error'
    task.object_send(:update_and_notify_parent, 
                     :state => 'finished', 
                     :status => 'Error',
                     :message => "#{status || "Unknown error occurred:"} [#{$evm.object.current_field_name}]")
                     exit MIQ_OK
  elsif status == "provision_complete"

	$evm.log(:info, "Task object service name #{task[:options][:vm_provision_requests][0][:options][:service_name]}")
	$evm.log(:info, "Task object service id #{task[:options][:vm_provision_requests][0][:options][:service_id]}")
	task.finished("Provision Complete, Service Name: #{task[:options][:vm_provision_requests][0][:options][:service_name]} Service Id: #{task[:options][:vm_provision_requests][0][:options][:service_id]}")

  elsif ae_result == 'retry'
    step = $evm.current_object.current_field_name
    num_retry = $evm.root['ae_state_retries']
    $evm.log("info", "Polling: #{ $evm.root['ae_reason'] }")
    task.message = "Polling #{num_retry}: #{ $evm.root['ae_reason'] } [#{step}]"
  else
    task.message = status unless status == '_blank_'
  end
rescue => err
  $evm.log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
end
