###################################
#
# EVM Automate Method: Provision
#
# Notes: This method launches the provisioning job
#
###################################

# Method for logging
def log(level, message)
  @method = 'provision'
  $evm.log(level, "#{@method} - #{message}")
end

begin
  log(:info, "CFME Automate Method Started")

  # Get provisioning object
  prov = $evm.root['miq_provision']
  log(:info, "Provision:<#{prov.id}> Request:<#{prov.miq_provision_request.id}> Type:<#{prov.type}>")

  # Execute provision task
  prov.execute

  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

  # Set Ruby rescue behavior
rescue => err
  $evm.log("error", "[#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
