def dump_root()
  $evm.log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
  $evm.log(:info, "Root:<$evm.root> End $evm.root.attributes")
  $evm.log(:info, "")
end

def error(msg)
  $evm.log(:error, msg)
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = msg
  exit MIQ_OK
end

def retry_method(msg, retry_time=1.minute)
  $evm.log(:warn, "#{msg}")
  $evm.root['ae_result'] = 'retry'
  $evm.root['ae_retry_interval'] = retry_time
  exit MIQ_OK
end

begin
  dump_root()
  
  task = $evm.root['miq_provision']
  
  attrs = task.get_option(:ws_values) || {}
  if attrs[:throttle_provision] == 't'
    max_concurrent_provisions = $evm.current['max_concurrent_provisions']
    $evm.log(:info, "Throttling VM provision request: [#{task.id}][max concurrent: #{max_concurrent_provisions}]")
    
    requests = $evm.vmdb('miq_provision_request').find(:all, :conditions => ["id < ? AND status = 'Ok' AND request_state != 'finished'", task.miq_request.id])
    retry_method("Too many concurrent requests: [#{requests.length}]") if requests.length >= max_concurrent_provisions
  end
  
  $evm.root['ae_result'] = 'ok'

rescue => err
  error("[#{err}]\n#{err.backtrace.join("\n")}")
end
