###################################
#
# CFME Automate Method: DeleteFromVMDB
#
# Notes: This method removes the VM from the VMDB database
#
###################################

# Method for logging
def log(level, message)
  @method = 'DeleteFromVMDB'
  $evm.log(level, "#{@method} - #{message}")
end

def error(msg)
  log(:error, "#{msg}")
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = msg
  exit MIQ_OK
end

begin
  log(:info, "CFME Automate Method Started")

  vm = $evm.root['vm']
  error("Failed to retrieve VM") unless vm

  log(:info, "Deleting VM:<#{vm.name}> from VMDB")
  vm.remove_from_vmdb

  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

rescue => err
  error("[#{err}]\n#{err.backtrace.join("\n")}")
end
