###################################
#
# CFME Automate Method: PreDeleteFromProvider
#
# Notes: This retirement method runs prior to deleting the VM from the Provider
#
#
###################################
begin
  # Method for logging
  def log(level, message)
    @method = 'PreDeleteFromProvider'
    $evm.log(level, "#{@method} - #{message}")
  end

  # dump_root
  def dump_root()
    log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
    $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
    log(:info, "Root:<$evm.root> End $evm.root.attributes")
    log(:info, "")
  end

  log(:info, "CFME Automate Method Started")

  # dump all root attributes to the log
  dump_root

  # Get vm from root object
  vm = $evm.root['vm']

  unless vm.nil?
    power_state = vm.attributes['power_state']
    ems = vm.ext_management_system
    log(:info, "VM:<#{vm.name}> on Provider:<#{ems ? ems.name : nil} has Power State:<#{power_state}>")
  end

  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

  # Set Ruby rescue behavior
rescue => err
  log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
