###################################
#
# CFME Automate Method: RemoveService
#
# This method is executed when the provision request is auto-approved
#
# Event: /System/Event/service_retired
# 
###################################
begin
  # Method for logging
  def log(level, message)
    @method = 'RemoveService'
    $evm.log(level, "#{@method} - #{message}")
  end

  # dump_root
  def dump_root()
    log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
    $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
    log(:info, "Root:<$evm.root> End $evm.root.attributes")
    log(:info, "")
  end

  log(:info, "CFME Automate Method Started")

  # dump all root attributes to the log
  dump_root

  service = $evm.vmdb("service", $evm.root['service_id'])
  raise "$evm.root['service'] object not found" if service.nil?

  log(:info, "Removing Service:<#{service.name}> from CFME database")
  service.remove_from_vmdb

  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

  # Set Ruby rescue behavior
rescue => err
  log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
