###################################
#
# CFME Automate Method: UnregisterFromProvider
#
# Notes: This method unregisters the VM from the Provder
#
###################################
begin
  # Method for logging
  def log(level, message)
    @method = 'UnregisterFromProvider'
    $evm.log(level, "#{@method} - #{message}")
  end

  # dump_root
  def dump_root()
    log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
    $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
    log(:info, "Root:<$evm.root> End $evm.root.attributes")
    log(:info, "")
  end

  log(:info, "CFME Automate Method Started")

  # dump all root attributes to the log
  dump_root

  vm = $evm.root['vm']
  unless vm.nil?
    ems = vm.ext_management_system
    log(:info, "Unregistering VM:<#{vm.name}> from EMS:<#{ems ? ems.name : nil}")
    vm.unregister
  end

  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

  # Set Ruby rescue behavior
rescue => err
  log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
