###################################
#
# CFME Automate Method: get_cpu_quota
#
# Author: Nick Lane
#
# Notes: Retrieve the memory quota for the selected group
#
# Inputs: hosting_segment
#
###################################

def log(level, message) 
  @method = 'get_cpu_quota' 
  $evm.log(level, "#{@method} - #{message}") 
end

def build_dialog_values(lf_array)
  quotas = lf_array.join(" | ")
  # CFME does not properly handle sorted dynamic field
  list_values = {
    'sort_by'       => :none,
    'data_type'     => :string,
    'required'      => false,
    'default_value' => nil,
    'values'        => [[quotas, quotas]]
  } 

  $evm.log('info', "Template drop-down: [#{list_values}]")
  list_values.each { |k,v| $evm.object[k] = v }
end

begin
  #hosting_segment = $evm.inputs['hosting_segment']

 # $evm.log(:info, "Input: #{hosting_segment}")

  hosting_segment = $evm.inputs['dialog_hosting_segment'].chomp

  $evm.log(:info, "Input: #{hosting_segment}")


  #group = $evm.vmdb('miq_group').all.select {|test_group| test_group.description == hosting_segment}.first
  
  log(:info, "Root: $evm.root Begin $evm.root.attributes")
  $evm.root.attributes.sort.each { |k, v| log(:info, "Root: $evm.root Attribute - #{k}: #{v}")}
  log(:info, "Root: $evm.root End $evm.root.attributes")
  log(:info, "")

  group = $evm.root['user'].miq_group

  $evm.log(:info, "Group = #{group}")
  tags = group.tags

  log(:info, "Tags = #{tags}")
  quota_array = Array.new
  #tags.each { |tag|
      mem_quota = group.tags("intuit_mem_#{hosting_segment}_quota".to_sym).first.to_i
      $evm.log(:info, "Tag: #{mem_quota}")
      quota_array.push "MEM:#{mem_quota}"
      cpu_quota = group.tags("intuit_cpu_#{hosting_segment}_quota".to_sym).first.to_i
      $evm.log(:info, "Tag: #{cpu_quota}")
      quota_array.push "CPU:#{cpu_quota}"
  #  if tag.include? "cpu_{hosting_segment}_quota"
  #      $evm.log(:info, "Tag: #{tag}")
  #      tagging = tag.split("/")
  #      value = tagging.last
  #      quota_array.push "CPU:#{value}"
  #  end
  #  if tag.include? "mem_{hosting_segment}_quota"
  #      $evm.log(:info, "Tag: #{tag}")
  #      tagging = tag.split("/")
  #      value = tagging.last
  #      quota_array.push "MEM:#{value}"
  #  end
  #}

  log(:info, "Quota Array: #{quota_array}")

  build_dialog_values(quota_array)
rescue => err
  $evm.log(:info, "[#{err}]\n#{err.backtrace.join("\n")}")
end
