###################################
#
# CFME Automate Method: get_mem_quota
#
# Author: Nick Lane
#
# Notes: Retrieve the memory quota for the selected group
#
# Inputs: group_name
#
###################################

def build_dialog_values(lf_array)
  # CFME does not properly handle sorted dynamic field
  list_values = {
    'sort_by'       => :none,
    'data_type'     => :string,
    'required'      => true,
    'default_value' => nil,
    'values'        => [[lf_array.last,lf_array.last]]
  } 

  $evm.log('info', "Template drop-down: [#{list_values}]")
  list_values.each { |k,v| $evm.object[k] = v }
end

begin
  #group_name = $evm.inputs['group_name']

 # $evm.log(:info, "Input: #{group_name}")

  group_name = $evm.inputs['dialog_group_name']

  $evm.log(:info, "Input: #{group_name}")


  group = $evm.vmdb('miq_group').all.select {|test_group| test_group.description == group_name}.first
  
  $evm.log(:info, "Group = #{group}")
  tags = group.tags
  tags.each { |tag|
    if tag.include? "mem_quota"
        $evm.log(:info, "Tag: #{tag}")
        tagging = tag.split("/")
        name = tagging.first
        value = tagging.last
        $evm.log(:info, "Tagging: #{name} - #{value}")
        build_dialog_values(tagging)
    end
  }
rescue => err
  $evm.log(:info, "[#{err}]\n#{err.backtrace.join("\n")}")
end
