#Automate Method # 

EVM_GROUP = "EvmGroup"
def log(level, message) 
  @method = 'list_miq_groups' 
  $evm.log(level, "#{@method} - #{message}") 
end

# dump_root 
def dump_root() 
  log(:info, "Root:<$evm.root> Begin $evm.root.attributes") 
  $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")} 
  log(:info, "Root:<$evm.root> End $evm.root.attributes") 
  log(:info, "") 
end 

def build_dialog_values(groups)
  # CFME does not properly handle sorted dynamic fields
  list_values = {
    'sort_by'    => :none,
    'data_type'  => :string,
    'required'   => true,
    'values'     => [[nil, nil]] + groups.sort_by { |x| x.description }.collect { |x| [x.description, x.description] }
  }

  #$evm.log(:info, "Miq Groups drop-down: [#{list_values}]")
  list_values.each { |k,v| $evm.object[k] = v }
end

begin 
  $evm.log("info", "Automate Method Started") 
  groups = $evm.vmdb('miq_group').all
  groups.delete_if{|group| group.description.include? EVM_GROUP}
  build_dialog_values(groups) 
  $evm.log("info", "Automate Method Ended") 
  exit MIQ_OK 
rescue => err 
  $evm.log("error", "<#{@method}>: [#{err}]\n#{err.backtrace.join("\n")}") 
  exit MIQ_STOP 
end
