###################################
#
# CFME Automate Method: POC_Dialog_ListProvisioningTemplates
#
# Notes: Build Dialog of available tempalates that match a certain criteria
#
###################################
begin
  # Method for logging
  def log(level, message)
    @method = 'POC_Dialog_ListProvisioningTemplates'
    $evm.log(level, "#{@method} - #{message}")
  end

  # dumpRoot
  def dump_root
    log(:info, "Root:<$evm.root> Begin Attributes")
    $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attributes - #{k}: #{v}")}
    log(:info, "Root:<$evm.root> End Attributes")
    log(:info, "")
  end

  log(:info, "CFME Automate Method Started")

  # dump all root attributes to the log
  dump_root

  # get an array of templates that meet this criteria
  templates = Array.new
  templates = $evm.vmdb('miq_template').all.collect { |template| [template[:name], template[:guid]] if ! template.archived && template.tagged_with?('prov_scope', 'all') && template.tags(category='intuit_hpsa_agent_url') && template.tags(category='intuit_hpsa_baseline') && template.tags(category='intuit_server_type')}
  templates.push("nope")
  # build a dialog of templates
  dialog_field               = $evm.object
  dialog_field["values"]     = templates.compact
  dialog_field["data_type"]  = "string"
  dialog_field["required"]   = "true"
  dialog_field["sort_by"]    = "description"
  dialog_field["sort_order"] = "ascending"
  log(:info, "Dialog Values:<#{dialog_field['values'].inspect}>")

  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

  # Set Ruby rescue behavior
rescue => err
  log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
