###################################
#
# CFME Automate Method: qdcc_List_Security_Zone_Dialog_tag_1
#
# Notes:
#
# Inputs:
#
###################################
begin
  # Method for logging
  def log(level, message)
    @method = 'qdcc_List_Security_Zone_Dialog_tag_1'
    $evm.log(level, "#{@method} - #{message}")
  end

  # dump_root
  def dump_root()
    log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
    $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
    log(:info, "Root:<$evm.root> End $evm.root.attributes")
    log(:info, "")
  end

  # Start
  log(:info, "CFME Automate Method Started")

  # dump all root attributes to the log
  dump_root

  hosting_segment = 'qdcc'
  log(:info, "Found #{$evm.root['dialog_tag_1_intuit_hs']} via $evm.root['dialog_tag_1_intuit_hs']")

  security_zone_hash = {}

  clusters = $evm.vmdb('ems_cluster').all.each do |cluster|
    next unless cluster.tagged_with?('prov_scope', 'all')
    next unless cluster.tagged_with?('intuit_hs', hosting_segment)
    log(:info, "Inspecting Cluster:<#{cluster.name}> tags: #{cluster.tags.inspect}")
    security_zone_hash[cluster.tags(:intuit_sz).last] = cluster.tags(:intuit_sz).first
  end

  log(:info, "Inspecting security_zone_hash:<#{security_zone_hash.inspect}>")

  # build
  list_values = {
    'sort_by'    => :none,
    'sort_order' => :ascending,
    'data_type'  => :string,
    'required'   => false,
    'values'     => [[nil, nil]] + security_zone_hash.to_a.collect { |x| x.reverse }
  }

  $evm.log('info', "Dynamic drop-down parameters: [#{list_values}]")
  list_values.each { |k,v| $evm.object[k] = v }

  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

  # Ruby rescue
rescue => err
  log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
