##################################
#
# CFME Automate Method: get_services
#
# Author: Nick Lane
#
# Notes: Retrieve a list of all online templates
#
###################################


def error(msg)
  $evm.log(:error, msg)
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = msg
  exit MIQ_OK
end

def dump_root()
  $evm.log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
  $evm.log(:info, "Root:<$evm.root> End $evm.root.attributes")
  $evm.log(:info, "")
end

def get_services(group, current_service)
	services = $evm.vmdb('service').all.select { |service| (service.miq_group_id == group.id) && (service.id != current_service)}
	#services.each { |service| $evm.log(:info, "services: #{service.inspect_all}")}
	#return services
end

def build_dialog_values(lf_array)
  # CFME does not properly handle sorted dynamic fields
  values = lf_array.sort_by { |x| x.name }.to_a.collect { |x| [x.name, x.id] }

  $evm.log(:info, "values: #{values}")
  #values = lf_array.collect { |service| service.name, 
  list_values = {
    'sort_by'       => :none,
    'data_type'     => :string,
    'required'      => true,
    'default_value' => values.first,
    'values'        => [[nil,nil]] + values
  }

  $evm.log('info', "Template drop-down: [#{list_values}]")
  list_values.each { |k,v| $evm.object[k] = v }
end

begin
  dump_root()
  
  user = $evm.root['user']
  current_service = $evm.root['service_id']
  group = user.miq_group

  lf_array = get_services(group, current_service)

  build_dialog_values(lf_array)
  
rescue => err
  error("[#{err}]\n#{err.backtrace.join("\n")}")
end
