###################################
#
# CFME Automate Method: get_project_template
#
# Author: Bryan Antigua
#
# Notes: Retrieve a list of all Service Project Objects
#
# Inputs: 
#
###################################

def error(msg)
  $evm.log(:error, msg)
  $evm.root['ae_result'] = 'error'
  $evm.root['ae_reason'] = msg
  exit MIQ_OK
end

def escape_uri(value)
  URI.escape("#{value}", Regexp.new("[^#{URI::PATTERN::UNRESERVED}]"))
end

def dump_root()
  $evm.log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
  $evm.root.attributes.sort.each { |k, v| $evm.log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
  $evm.log(:info, "Root:<$evm.root> End $evm.root.attributes")
  $evm.log(:info, "")
end

def get_project_template_list()
  services = $evm.vmdb('service').all.delete_if {|service| !service.tagged_with?('project_template','project_template')}
end


def build_dialog_values(project_template_list)
  # CFME does not properly handle sorted dynamic fields
  list_values = {
    'sort_by'    => :none,
    'data_type'  => :string,
    'required'   => true,
    'values'     => [[nil, nil]] + project_template_list.sort_by { |x| x['name'] }.collect { |x| [x['name'], x['id']] }
  }

  $evm.log(:info, "Project Template drop-down: [#{list_values}]")
  list_values.each { |k,v| $evm.object[k] = v }
end

begin
  $evm.log(:info, "Automate Method Started")
  project_template_list = get_project_template_list()
  build_dialog_values(project_template_list)
  $evm.log("info", "Automate Method Ended")

rescue => err
  error("[#{err}]\n#{err.backtrace.join("\n")}")
end
