###################################
#
# EVM Automate Method: group_specific_quotas
#
# Notes: This method allows for specific quotas based on ldap group membership
#
###################################
begin
  @method = 'group_specific_quotas'
  $evm.log("info", "===== EVM Automate Method: <#{@method}> Started")

  # Get ldap Group
  $evm.log("info", "Starting check for Individual Team Quotas")
  group = $evm.root['miq_request'].requester.ldap_group rescue nil

  # max_group_cpu = total cpu count
  # max_group_memory = total memory allocated to group in MBs
  # max_group_storage = total memory allocated to group in GBs

  $evm.log("info", "Checking for specific quota for group: <#{group}>")

  if group == "poc"
    $evm.log("info", "Setting Quota Thresholds for Group <#{group}>")
    #    $evm.current['max_group_cpu'] = '0'
    #    $evm.log("info", "Max CPU allowed for Group: <#{$evm.current['max_group_cpu']}>")
    #   $evm.current['max_group_memory'] = '4080'
    #   $evm.log("info", "Max Memory allowed for Group: <#{$evm.current['max_group_memory']}>")
    #   $evm.current['max_group_storage'] = '0'
    #   $evm.log("info", "Max Storage allowed for Group: <#{$evm.current['max_group_storage']}>")
    exit(MIQ_OK)
  end

  if group == "demo-test"
    $evm.log("info", "Setting Quota Thresholds for Group <#{group}>")
    $evm.current['max_group_cpu'] = '10'
    $evm.log("info", "Max CPU allowed for Group: <#{$evm.current['max_group_cpu']}>")
    $evm.current['max_group_memory'] = '40960'
    $evm.log("info", "Max Memory allowed for Group: <#{$evm.current['max_group_memory']}>")
    $evm.current['max_group_storage'] = '1500'
    $evm.log("info", "Max Storage allowed for Group: <#{$evm.current['max_group_storage']}>")
    exit(MIQ_OK)
  end

  #
  # Exit method
  #
  $evm.log("info", "===== EVM Automate Method: <#{@method}> Ended")
  exit MIQ_OK

  #
  # Set Ruby rescue behavior
  #
rescue => err
  $evm.log("error", "<#{@method}>: [#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
