###################################
#
# EVM Automate Method: PowerOn_DHOB
#
# Notes: PowerOn During Hours of Business is triggered via a Custom Button
# and allows VM's to be powered on only during business hours
#
#
###################################
begin
  @method = 'PowerOn_DHOB'
  $evm.log("info", "===== EVM Automate Method: <#{@method}> Started")

  # Turn of verbose logging
  @debug = true

  # Set Business Hour here using 24 hour clock
  after_hours = 17

  #
  # Initialize variables
  #

  # Get VM object
  #vm = $evm.object["vm"]
  vm = $evm.root['vm']

  unless Time.now.hour > after_hours
    $evm.log("info","Powering on VM: <#{vm.name}>")
    vm.start
  else
    $evm.log("info","Cannot power on VM: <#{vm.name.downcase}> due to Business Hours <#{after_hours}> Violation.")
  end

  #
  # Exit method
  #
  $evm.log("info", "===== EVM Automate Method: <#{@method}> Ended")
  exit MIQ_OK

  #
  # Set Ruby rescue behavior
  #
rescue => err
  $evm.log("error", "<#{@method}>: [#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
