###################################
#
# EVM Automate Method: vdi_reboot
#
# Notes: This method reboots the VDI endpoint for a VM
#
#
###################################
begin
  @method = 'vdi_reboot'
  $evm.log("info", "===== EVM Automate Method: <#{@method}> Started")

  # Turn of verbose logging
  @debug = true


  $evm.log("info", "===========================================")
  process = $evm.object("process")
  $evm.log("info", "Listing Process Attributes:")
  process.attributes.sort.each { |k, v| $evm.log("info", "\t#{k}: #{v}")} if @debug

  current = $evm.object
  $evm.log("info", "Listing Current Object Attributes:")
  current.attributes.sort.each { |k, v| $evm.log("info", "\t#{k}: #{v}")} if @debug

  $evm.log("info", "===========================================")

  vm = current["vm"]
  $evm.log("info", "Inspecting VM: <#{vm.inspect}>") if @debug

  cmd = "snmpset -v1 -c public #{vm.vdi_endpoint_ip_address} SNMPv2-SMI::enterprises.714.1.2.6.1.1.0 i: 0"
  $evm.log("info", "CMD: #{cmd}")
  result = `#{cmd}`
  $evm.log("info", "Command completed: result=#{result}")

  $evm.log("info", "Device ReStarted")


  #
  # Exit method
  #
  $evm.log("info", "===== EVM Automate Method: <#{@method}> Ended")
  exit MIQ_OK

  #
  # Set Ruby rescue behavior
  #
rescue => err
  $evm.log("error", "<#{@method}>: [#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
