###################################
#
# EVM Automate Method: vmname_sample3
#
# Notes: This method names the vm based on tag category chosen in dialog
#
###################################
begin
  @method = 'vmname_sample3'
  $evm.log("info", "===== EVM Automate Method: <#{@method}> Started")

  # Turn of verbose logging
  @debug = true

  #
  # Get variables
  #
  prov = $evm.root['miq_provision_request'] || $evm.root['miq_provision'] || $evm.root['miq_provision_request_template']
  vm_name = prov.get_option(:vm_name).to_s.strip
  number_of_vms_being_provisioned = prov.get_option(:number_of_vms)


  #
  # Get tags needed for VM Name
  #
  tags = prov.get_tags
  $evm.log("info","Tags: #{tags.inspect}") if @debug


  #
  # Construct vmname
  #

  # Prefix vmname with a static prefix of tag category
  prefix = tags[:environment]
  $evm.log("info","Environment Prefix: <#{prefix}>")

  # Get vm_name from dialog entry
  input_name = vm_name.downcase.strip
  $evm.log("info","VM input name: <#{input_name}>")

  derived_name = "#{prefix}#{input_name}"

  # Set the evm object to the vmname
  $evm.object['vmname'] = derived_name
  $evm.log("info", "VM Naming Method Completed: vmname=#{derived_name}")


  #
  # Exit method
  #
  $evm.log("info", "===== EVM Automate Method: <#{@method}> Ended")
  exit MIQ_OK

  #
  # Set Ruby rescue behavior
  #
rescue => err
  $evm.log("error", "<#{@method}>: [#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
