cluster = $evm.root['ems_cluster']

#$evm.log(:info, "Cluster Attributes: #{cluster.attributes}")
$evm.log(:info, "Cluster Inspection: #{cluster.inspect}")
$evm.log(:info, "Cluster Aggregate Physical CPUs: #{cluster.aggregate_physical_cpus}")
$evm.log(:info, "Cluster Aggregate VM CPUs: #{cluster.aggregate_vm_cpus}")
$evm.log(:info, "Cluster Aggregate Logical CPUs: #{cluster.aggregate_logical_cpus}")
#$evm.log(:info, "Cluster somthing: #{cluster.max_cpu_usage_rate_average_avg_over_time_period}")
#$evm.log(:info, "Cluster againL #{cluster.max_mem_usage_absolute_average_avg_over_time_period_without_overhead}")
#$evm.log(:info, "Derived Memory: #{cluster.derived_memory_used_avg_over_time_period}")
$evm.log(:info, "Cluster Effective CPU: #{cluster.effective_cpu}")
#$evm.log(:info, "Cluster Ratio:#{cluster.capacity_profile_1_vcpu_commitment_ratio}")
#$evm.log(:info, "Cluster Ratio 2:#{cluster.capacity_profile_2_vcpu_commitment_ratio}")
$evm.log(:info, "Cluster vcpu ratio whatever: #{cluster.v_cpu_vr_ratio}")
$evm.log(:info, "Cluster Mem ratio: #{cluster.v_ram_vr_ratio}")
#$evm.log(:info, "Cluster Mem method: #{cluster.capacity_profile_1_memory_method}")
cluster_cpu = cluster.effective_cpu.to_i

total_cpu = 0
derived_cpu = 0

def countAllocatedCpuInHost(host)
  vms = host.vms.find_all
  cpu_count = 0
  vms.each do |vm|
    cpu_count += vm.num_cpu.to_i
  end

  return cpu_count
end

  # In the host, find all the VMs and sum up the allocated memory.
def sumAllocatedMemInHost(host)
    vms = host.vms.find_all
    mem_sum = 0

    vms.each do |vm|
      mem_sum += vm.mem_cpu.to_i
    end

    return mem_sum
end

mem_test = 0
cpu_test = 0

hosts = cluster.hosts
hosts.each {|host|
  mem_test += sumAllocatedMemInHost(host)
  cpu_test += countAllocatedCpuInHost(host)
  $evm.log(:info, "Host average usage: #{host.cpu_usagemhz_rate_average_avg_over_time_period}")
  $evm.log(:info, "Host Derived: #{host.derived_memory_used_avg_over_time_period}")
  total_cpu = total_cpu + host.cpu_usagemhz_rate_average_avg_over_time_period.to_i
  derived_cpu = derived_cpu + host.derived_memory_used_avg_over_time_period.to_i
}

$evm.log(:info, "Memory Allocation: #{mem_test}")
$evm.log(:info, "CPU Allocation: #{cpu_test}")




percent_usage = total_cpu.fdiv(cluster_cpu)
percent_derived = derived_cpu.fdiv(cluster_cpu)

$evm.log(:info, "Total Host usage: #{total_cpu}")
$evm.log(:info, "Total Derived usage: #{derived_cpu}")
$evm.log(:info, "Total Effective: #{cluster_cpu}")
$evm.log(:info, "Percent usage: #{percent_usage.inspect}")
$evm.log(:info, "Percent derived: #{percent_derived.inspect}")
