###################################
#
# CFME Automate Method: parse_call_instance
#
# Notes: This method parses incoming variables for call_instance
#
###################################
begin
  # Method for logging
  def log(level, message)
    @method = 'parse_call_instance'
    $evm.log(level, "#{@method} - #{message}")
  end

  # dump_root
  def dump_root()
    log(:info, "Root:<$evm.root> Begin $evm.root.attributes")
    $evm.root.attributes.sort.each { |k, v| log(:info, "Root:<$evm.root> Attribute - #{k}: #{v}")}
    log(:info, "Root:<$evm.root> End $evm.root.attributes")
    log(:info, "")
  end

  log(:info, "CFME Automate Method Started")

  # dump all root attributes to the log
  dump_root

  unless $evm.root['namespace'].blank? || $evm.root['class'].blank? 
    $evm.root['instance'] = 'Default' if $evm.root['instance'].blank?
    # instantiate incoming path
    $evm.instantiate("/#{$evm.root['namespace']}/#{$evm.root['class']}/#{$evm.root['instance']}")
  end

  # Exit method
  log(:info, "CFME Automate Method Ended")
  exit MIQ_OK

  # Ruby rescue
rescue => err
  log(:error, "[#{err}]\n#{err.backtrace.join("\n")}")
  exit MIQ_ABORT
end
